import { Directive, ElementRef, Input, Component, HostBinding, TemplateRef, ViewContainerRef, EventEmitter, forwardRef, Injector, Output, ViewChild, HostListener, ContentChildren, NgModule } from '@angular/core';
import { NG_VALIDATORS, NgControl, NG_VALUE_ACCESSOR, NgModel, FormControlName, NgForm, FormsModule, ReactiveFormsModule } from '@angular/forms';
import 'reflect-metadata';
import { CommonModule } from '@angular/common';
import { TranslateModule } from '@ngx-translate/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/reflect-input.models.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ParamInputModel() { }
if (false) {
    /** @type {?|undefined} */
    ParamInputModel.prototype.value;
    /** @type {?|undefined} */
    ParamInputModel.prototype.field;
    /** @type {?} */
    ParamInputModel.prototype.error;
    /** @type {?|undefined} */
    ParamInputModel.prototype.customValue;
    /** @type {?|undefined} */
    ParamInputModel.prototype.customFunc;
}
/**
 * @record
 */
function RangeInputModel() { }
if (false) {
    /** @type {?|undefined} */
    RangeInputModel.prototype.min;
    /** @type {?|undefined} */
    RangeInputModel.prototype.max;
    /** @type {?} */
    RangeInputModel.prototype.error;
}
/** @enum {number} */
const DataTypeEnum = {
    Int: 0,
    Number: 1,
    MultilineText: 2,
    Url: 3,
    ImageUrl: 4,
    Password: 5,
    Hexadecimal: 6,
    Date: 7,
    Array: 8,
    Upload: 9,
};
DataTypeEnum[DataTypeEnum.Int] = 'Int';
DataTypeEnum[DataTypeEnum.Number] = 'Number';
DataTypeEnum[DataTypeEnum.MultilineText] = 'MultilineText';
DataTypeEnum[DataTypeEnum.Url] = 'Url';
DataTypeEnum[DataTypeEnum.ImageUrl] = 'ImageUrl';
DataTypeEnum[DataTypeEnum.Password] = 'Password';
DataTypeEnum[DataTypeEnum.Hexadecimal] = 'Hexadecimal';
DataTypeEnum[DataTypeEnum.Date] = 'Date';
DataTypeEnum[DataTypeEnum.Array] = 'Array';
DataTypeEnum[DataTypeEnum.Upload] = 'Upload';
/**
 * @record
 */
function DecoratorReturnModel() { }
if (false) {
    /** @type {?} */
    DecoratorReturnModel.prototype.key;
    /** @type {?} */
    DecoratorReturnModel.prototype.value;
}
/**
 * @record
 */
function CssInputModel() { }
if (false) {
    /** @type {?|undefined} */
    CssInputModel.prototype.group;
    /** @type {?|undefined} */
    CssInputModel.prototype.label;
    /** @type {?|undefined} */
    CssInputModel.prototype.input;
    /** @type {?|undefined} */
    CssInputModel.prototype.error;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/reflector-functions.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} obj
 * @return {?}
 */
function isEmpty(obj) {
    for (const key in obj) {
        if (obj.hasOwnProperty(key)) {
            return false;
        }
    }
    return true;
}
/**
 * @template T
 * @param {?} constructor
 * @return {?}
 */
function ModelState(constructor) {
    return class extends constructor {
        /**
         * Returns model validation state
         * @return {?}
         */
        IsValid() {
            for (const item of Reflect.getMetadataKeys(this)) {
                /** @type {?} */
                const attribs = getDecorators(this, item);
                for (const attrib of attribs.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.key !== 'ReadOnly' && x.key !== 'NoForm'))) {
                    /** @type {?} */
                    const messg = ngxValidate(attrib.key, attrib.value, this[item], this);
                    if (messg) {
                        return false;
                    }
                }
            }
            return true;
        }
        /**
         * Placeholder(string)
         * Validate: function
         * @return {?}
         */
        ModelErrors() {
            /** @type {?} */
            const errs = {};
            /** @type {?} */
            let tmp = {};
            for (const item of Reflect.getMetadataKeys(this)) {
                /** @type {?} */
                const attribs = getDecorators(this, item);
                for (const attrib of attribs.filter((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.key !== 'ReadOnly' && x.key !== 'NoForm'))) {
                    /** @type {?} */
                    const messg = ngxValidate(attrib.key, attrib.value, this[item], this);
                    if (messg) {
                        tmp[attrib.key] = messg;
                    }
                }
                if (!isEmpty(tmp)) {
                    errs[item] = tmp;
                }
                tmp = {};
            }
            return errs;
        }
    };
}
/**
 * Validates field if it has valid value according to value parameter
 * @param {?} param
 * @return {?}
 */
function DataType(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:DataType', param, target, propertyKey);
    });
}
/**
 * Validates field if it represents valid credit card number
 * @param {?} param
 * @return {?}
 */
function CreditCard(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:CreditCard', param, target, propertyKey);
    });
}
/**
 * Compares field to other field and checks if they are equal
 * @param {?} param
 * @return {?}
 */
function Compare(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Compare', param, target, propertyKey);
    });
}
/**
 * Validates if field value contains specific value
 * @param {?} param
 * @return {?}
 */
function Contains(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Contains', param, target, propertyKey);
    });
}
/**
 * Validates field according to custom logic
 * @param {?} param
 * @return {?}
 */
function Custom(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Custom', param, target, propertyKey);
    });
}
/**
 * Sets the name metadata for the field
 * @param {?} param
 * @return {?}
 */
function Name(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Name', param, target, propertyKey);
    });
}
/**
 * Validates field and checks if it has null, undefined or empty value
 * @param {?} param
 * @return {?}
 */
function Required(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Required', param, target, propertyKey);
    });
}
/**
 * Validates field if other field has specific value and checks if it has null, undefined or empty value
 * @param {?} param
 * @return {?}
 */
function RequiredIf(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:RequiredIf', param, target, propertyKey);
    });
}
/**
 * Sets field's input value to readonly
 * @return {?}
 */
function ReadOnly() {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, propertyKey, target);
        Reflect.defineMetadata('custom-reflect:ReadOnly', null, target, propertyKey);
    });
}
/**
 * Validates if field has valid value according to specified pattern
 * @param {?} param
 * @return {?}
 */
function Pattern(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:Pattern', param, target, propertyKey);
    });
}
/**
 * Validates if field has valid value more than specific value
 * @param {?} input
 * @return {?}
 */
function MinValue(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:MinValue', input, target, propertyKey);
    });
}
/**
 * Validates if field has valid value less than specific value
 * @param {?} input
 * @return {?}
 */
function MaxValue(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:MaxValue', input, target, propertyKey);
    });
}
/**
 * Validates if field value does not contain specific value
 * @param {?} param
 * @return {?}
 */
function NotContains(param) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, param, target);
        Reflect.defineMetadata('custom-reflect:NotContains', param, target, propertyKey);
    });
}
/**
 * Tells form generator component not to generate input for this field
 * @return {?}
 */
function NoForm() {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, propertyKey, target);
        Reflect.defineMetadata('custom-reflect:NoForm', null, target, propertyKey);
    });
}
/**
 * Validates if field value length fits in min and max values
 * @param {?} input
 * @return {?}
 */
function StringLength(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:StringLength', input, target, propertyKey);
    });
}
/**
 * Validates if field value is valid email value
 * @param {?} input
 * @return {?}
 */
function Email(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Email', input, target, propertyKey);
    });
}
/**
 * Sets placeholder value for field input
 * @param {?} input
 * @return {?}
 */
function Placeholder(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Placeholder', input, target, propertyKey);
    });
}
/**
 * Validates if field value length fits in min and max values
 * @param {?} input
 * @return {?}
 */
function Range(input) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @return {?}
     */
    function (target, propertyKey) {
        Reflect.defineMetadata(propertyKey, input, target);
        Reflect.defineMetadata('custom-reflect:Range', input, target, propertyKey);
    });
}
/**
 * @param {?} value
 * @return {?}
 */
function configurable(value) {
    return (/**
     * @param {?} target
     * @param {?} propertyKey
     * @param {?} descriptor
     * @return {?}
     */
    function (target, propertyKey, descriptor) {
        descriptor.configurable = value;
    });
}
/**
 * Placeholder(string)
 * Validate: function
 * @param {?} target
 * @param {?} propertyName
 * @return {?}
 */
function getDecorators(target, propertyName) {
    /** @type {?} */
    const keys = Reflect.getMetadataKeys(target, propertyName);
    /** @type {?} */
    const decorators = keys.filter((/**
     * @param {?} key
     * @return {?}
     */
    key => key.toString().startsWith('custom-reflect:')))
        .reduce((/**
     * @param {?} values
     * @param {?} key
     * @return {?}
     */
    (values, key) => {
        /** @type {?} */
        const value = Reflect.getMetadata(key, target, propertyName);
        return values.concat({ key: key.toString().replace('custom-reflect:', ''), value });
    }), []);
    return decorators;
}
/**
 * @param {?} key
 * @param {?} param
 * @param {?} value
 * @param {?=} dataModel
 * @return {?}
 */
function ngxValidate(key, param, value, dataModel) {
    /** @type {?} */
    let retstr;
    if ((value === null || value === undefined || value === '') && key !== 'Required' && key !== 'RequiredIf' && key !== 'Compare' && key !== 'Range') {
        return null;
    }
    /** @type {?} */
    let errorString = '';
    if (typeof param === 'string') {
        errorString = param;
    }
    else {
        errorString = param.error;
    }
    if (!errorString) {
        errorString = 'error not asigned!';
    }
    switch (key) {
        case 'CreditCard': {
            value = value.replace(/[- ]+/g, '');
            /** @type {?} */
            const Visa = /^4[0-9]{12}(?:[0-9]{3})?$/;
            /** @type {?} */
            const MasterCard = /^(?:5[1-5][0-9]{2}|222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}$/;
            /** @type {?} */
            const Amex = /^3[47][0-9]{13}$/;
            /** @type {?} */
            const DinersClub = /^3(?:0[0-5]|[68][0-9])[0-9]{11}$/;
            /** @type {?} */
            const Discover = /^6(?:011|5[0-9]{2})[0-9]{12}$/;
            /** @type {?} */
            const JCB = /^(?:2131|1800|35\d{3})\d{11}$/;
            /** @type {?} */
            const BCGlobal = /^(6541|6556)[0-9]{12}$/;
            /** @type {?} */
            const CarteBlanche = /^389[0-9]{11}$/;
            /** @type {?} */
            const InstaPayment = /^63[7-9][0-9]{13}$/;
            /** @type {?} */
            const KoreanLocalCard = /^9[0-9]{15}$/;
            /** @type {?} */
            const Laser = /^(6304|6706|6709|6771)[0-9]{12,15}$/;
            /** @type {?} */
            const Maestro = /^(5018|5020|5038|6304|6759|6761|6763)[0-9]{8,15}$/;
            /** @type {?} */
            const Solo = /^(6334|6767)[0-9]{12}|(6334|6767)[0-9]{14}|(6334|6767)[0-9]{15}$/;
            /** @type {?} */
            const Switch = /^(4903|4905|4911|4936|6333|6759)[0-9]{12}|(4903|4905|4911|4936|6333|6759)[0-9]{14}|(4903|4905|4911|4936|6333|6759)[0-9]{15}|564182[0-9]{10}|564182[0-9]{12}|564182[0-9]{13}|633110[0-9]{10}|633110[0-9]{12}|633110[0-9]{13}$/;
            /** @type {?} */
            const UnionPay = /^(62[0-9]{14,17})$/;
            if (!checkLuhn(value) ||
                !(Visa.test(value) || MasterCard.test(value) || Amex.test(value) || DinersClub.test(value) || Discover.test(value) || JCB.test(value)
                    || BCGlobal.test(value) || CarteBlanche.test(value) || InstaPayment.test(value) || KoreanLocalCard.test(value) || Laser.test(value)
                    || Maestro.test(value) || Solo.test(value) || Switch.test(value) || UnionPay.test(value) ||
                    (((/** @type {?} */ (param))).customValue && ((/** @type {?} */ (param))).customValue.test(value)))) {
                retstr = ((/** @type {?} */ (param))).error;
            }
            break;
        }
        case 'Compare': {
            if (value !== dataModel[((/** @type {?} */ (param))).field]) {
                retstr = errorString;
            }
            break;
        }
        case 'Contains': {
            if (value.indexOf(((/** @type {?} */ (param))).value) === -1) {
                retstr = errorString;
            }
            break;
        }
        case 'Custom': {
            /** @type {?} */
            const result = ((/** @type {?} */ (param))).customFunc(value, dataModel);
            if (!result) {
                retstr = errorString;
            }
            break;
        }
        case 'DataType': {
            if (((/** @type {?} */ (param))).value === DataTypeEnum.Number) {
                /** @type {?} */
                const reg = /^[+-]?\d+(\.\d+)?$/;
                if (isNaN(parseFloat(value)) || !reg.test(value)) {
                    retstr = errorString;
                }
            }
            if (((/** @type {?} */ (param))).value === DataTypeEnum.Date) {
                if (!(value instanceof Date)) {
                    retstr = errorString;
                }
            }
            if (((/** @type {?} */ (param))).value === DataTypeEnum.Hexadecimal) {
                /** @type {?} */
                const expression = /^([0-9a-fA-F]+)$/i;
                if (!expression.test(value)) {
                    retstr = errorString;
                }
            }
            if (((/** @type {?} */ (param))).value === DataTypeEnum.Int) {
                /** @type {?} */
                const reg = /^[+\-]?\d+$/;
                if (isNaN(parseFloat(value))
                    || !isNaN(parseFloat(value)) && (parseFloat(value) - parseInt(value, 10) !== 0)
                    || !reg.test(value)) {
                    retstr = errorString;
                }
            }
            if (((/** @type {?} */ (param))).value === DataTypeEnum.Array) {
                if (!Array.isArray(value)) {
                    retstr = errorString;
                }
            }
            break;
        }
        case 'NotContains': {
            if (value.indexOf(((/** @type {?} */ (param))).value) !== -1) {
                retstr = errorString;
            }
            break;
        }
        case 'Required': {
            if (value === null || value === undefined || value === '') {
                retstr = errorString;
            }
            break;
        }
        case 'RequiredIf': {
            if (!((/** @type {?} */ (param))).field || !((/** @type {?} */ (param))).value) {
                console.warn('incorrect parameters in RequiredIf attribute');
            }
            else {
                if ((((/** @type {?} */ (param))).value === dataModel[((/** @type {?} */ (param))).field]) && (value === null || value === undefined || value === '')) {
                    retstr = errorString;
                }
            }
            break;
        }
        case 'Pattern': {
            /** @type {?} */
            const pat = ((/** @type {?} */ (param))).value;
            if (!pat.test(value)) {
                retstr = errorString;
            }
            break;
        }
        case 'MinValue': {
            if (value < ((/** @type {?} */ (param))).value) {
                retstr = errorString.replace('{0}', ((/** @type {?} */ (param))).value.toString());
            }
            break;
        }
        case 'MaxValue': {
            if (value > ((/** @type {?} */ (param))).value) {
                retstr = errorString.replace('{0}', ((/** @type {?} */ (param))).value.toString());
            }
            break;
        }
        case 'StringLength': {
            if (!value || value.length < ((/** @type {?} */ (param))).min || value.length > ((/** @type {?} */ (param))).max) {
                retstr = errorString.replace('{0}', ((/** @type {?} */ (param))).min.toString()).replace('{1}', ((/** @type {?} */ (param))).max.toString());
            }
            break;
        }
        case 'Range': {
            if (value < ((/** @type {?} */ (param))).min || value > ((/** @type {?} */ (param))).max) {
                retstr = errorString.replace('{0}', ((/** @type {?} */ (param))).min.toString()).replace('{1}', ((/** @type {?} */ (param))).max.toString());
            }
            break;
        }
        case 'Email': {
            // credits http://emailregex.com/
            /** @type {?} */
            const emreg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if (!emreg.test(value)) {
                retstr = errorString;
            }
            break;
        }
        default: {
            retstr = null;
            break;
        }
    }
    return retstr;
}
/**
 * @param {?} value
 * @return {?}
 */
function checkLuhn(value) {
    // credits https://github.com/JamesEggers1/node-luhn
    /** @type {?} */
    const trimmed = String(value).replace(/[\s]/g, '');
    /** @type {?} */
    const length = trimmed.length;
    /** @type {?} */
    let odd = false;
    /** @type {?} */
    let total = 0;
    /** @type {?} */
    let calc;
    /** @type {?} */
    let calc2;
    if (length === 0) {
        return true;
    }
    if (!/^[0-9]+$/.test(trimmed)) {
        return false;
    }
    for (let i = length; i > 0; i--) {
        calc = parseInt(trimmed.charAt(i - 1), 10);
        if (!odd) {
            total += calc;
        }
        else {
            calc2 = calc * 2;
            switch (calc2) {
                case 10:
                    calc2 = 1;
                    break;
                case 12:
                    calc2 = 3;
                    break;
                case 14:
                    calc2 = 5;
                    break;
                case 16:
                    calc2 = 7;
                    break;
                case 18:
                    calc2 = 9;
                    break;
                default: calc2 = calc2;
            }
            total += calc2;
        }
        odd = !odd;
    }
    return (total !== 0 && (total % 10) === 0);
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/validate.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} control
 * @param {?} dataModel
 * @return {?}
 */
function validateControl(control, dataModel) {
    /** @type {?} */
    let name;
    if (control.parent) {
        for (const item of Object.keys(control.parent.controls)) {
            if (control.parent.controls[item] === control) {
                name = item;
            }
        }
    }
    else {
        name = this.field;
    }
    /** @type {?} */
    const attribs = getDecorators(dataModel, name);
    /** @type {?} */
    const errs = {};
    if (attribs.find((/**
     * @param {?} x
     * @return {?}
     */
    x => x.key === 'ReadOnly'))) {
        this.el.nativeElement.setAttribute('readonly', true);
    }
    for (const item of attribs.filter((/**
     * @param {?} x
     * @return {?}
     */
    x => x.key !== 'ReadOnly' && x.key !== 'NoForm'))) {
        /** @type {?} */
        const messg = ngxValidate(item.key, item.value, control.value, dataModel);
        if (messg) {
            errs[item.key] = messg;
        }
    }
    return errs;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-validator.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxValidatorDirective {
    /**
     * @param {?} el
     */
    constructor(el) {
        this.el = el;
        this.validator = validateControl;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set sk(value) {
        this.dataModel = value;
    }
    /**
     * @param {?} control
     * @return {?}
     */
    validate(control) {
        return this.validator(control, this.dataModel);
    }
}
NgxValidatorDirective.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line:directive-selector
                selector: '[ngx-validator][ngModel],[ngx-validator][formControl],[ngx-validator][formControlName]',
                providers: [
                    { provide: NG_VALIDATORS, useExisting: NgxValidatorDirective, multi: true }
                ]
            },] }
];
/** @nocollapse */
NgxValidatorDirective.ctorParameters = () => [
    { type: ElementRef }
];
NgxValidatorDirective.propDecorators = {
    field: [{ type: Input }],
    sk: [{ type: Input, args: ['ngx-validator',] }]
};
if (false) {
    /** @type {?} */
    NgxValidatorDirective.prototype.validator;
    /**
     * @type {?}
     * @private
     */
    NgxValidatorDirective.prototype.dataModel;
    /** @type {?} */
    NgxValidatorDirective.prototype.field;
    /**
     * @type {?}
     * @private
     */
    NgxValidatorDirective.prototype.el;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-label-for/ngx-label-for.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxLabelForComponent {
    constructor() {
        this.ngxLabel = true;
        this.reflectValue = '';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        try {
            this.reflectValue = getDecorators(this.model, this.field).find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'Name')).value;
        }
        catch (_a) {
            this.reflectValue = this.field;
        }
    }
}
NgxLabelForComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-label-for',
                template: "<label\r\n    for=\"{{field}}\"\r\n    class=\"ngx-label-child\">\r\n    {{reflectValue | translate}}\r\n</label>\r\n"
            }] }
];
NgxLabelForComponent.propDecorators = {
    model: [{ type: Input }],
    field: [{ type: Input }],
    ngxLabel: [{ type: HostBinding, args: ['class.ngx-label',] }]
};
if (false) {
    /** @type {?} */
    NgxLabelForComponent.prototype.model;
    /** @type {?} */
    NgxLabelForComponent.prototype.field;
    /** @type {?} */
    NgxLabelForComponent.prototype.ngxLabel;
    /** @type {?} */
    NgxLabelForComponent.prototype.reflectValue;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-validator-for/ngx-validator-for.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxValidatorForComponent {
    constructor() {
        this.messages = [];
        this.ngxLabel = true;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set errors(value) {
        this.messages = [];
        if (value) {
            for (const item of Object.keys(value)) {
                this.messages.push(value[item].toString());
            }
        }
    }
}
NgxValidatorForComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-validator-for',
                template: "<div class=\"ngx-validator-child\">\n    <div *ngFor=\"let message of messages\">\n        <ng-container *ngIf=\"message\">{{message | translate}}</ng-container>\n    </div>\n</div>\n"
            }] }
];
NgxValidatorForComponent.propDecorators = {
    ngxLabel: [{ type: HostBinding, args: ['class.ngx-validator',] }],
    errors: [{ type: Input, args: ['errors',] }]
};
if (false) {
    /** @type {?} */
    NgxValidatorForComponent.prototype.messages;
    /** @type {?} */
    NgxValidatorForComponent.prototype.ngxLabel;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-custom-template-for.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxCustomTemplateForDirective {
    /**
     * @param {?} templateRef
     * @param {?} viewContainer
     */
    constructor(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
    }
}
NgxCustomTemplateForDirective.decorators = [
    { type: Directive, args: [{
                // tslint:disable-next-line:directive-selector
                selector: '[ngxCustomTemplateFor]'
            },] }
];
/** @nocollapse */
NgxCustomTemplateForDirective.ctorParameters = () => [
    { type: TemplateRef },
    { type: ViewContainerRef }
];
NgxCustomTemplateForDirective.propDecorators = {
    ngxCustomTemplateFor: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NgxCustomTemplateForDirective.prototype.ngxCustomTemplateFor;
    /**
     * @type {?}
     * @private
     */
    NgxCustomTemplateForDirective.prototype.templateRef;
    /**
     * @type {?}
     * @private
     */
    NgxCustomTemplateForDirective.prototype.viewContainer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/value-accessor.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class ValueAccessorBase {
    /**
     * @param {?} theInjector
     */
    constructor(theInjector) {
        this.theInjector = theInjector;
        this.changed = null;
        this.touched = null;
    }
    /**
     * @protected
     * @return {?}
     */
    get formControl() {
        if (this.control != null) {
            return this.control;
        }
        this.control = this.theInjector.get(NgControl, null);
        return this.control;
    }
    /**
     * @return {?}
     */
    get value() {
        return this.innerValue;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) {
        if (this.innerValue !== value) {
            this.innerValue = value;
            this.changed(value);
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        this.innerValue = value;
        //this.changed(value);
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.changed = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.touched = fn;
    }
    /**
     * @param {?} disabled
     * @return {?}
     */
    setDisabledState(disabled) {
        this.disabled = disabled;
    }
    /**
     * @return {?}
     */
    touch() {
        this.touched();
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    ValueAccessorBase.prototype.innerValue;
    /**
     * @type {?}
     * @private
     */
    ValueAccessorBase.prototype.changed;
    /**
     * @type {?}
     * @private
     */
    ValueAccessorBase.prototype.touched;
    /** @type {?} */
    ValueAccessorBase.prototype.disabled;
    /**
     * @type {?}
     * @private
     */
    ValueAccessorBase.prototype.control;
    /**
     * @type {?}
     * @private
     */
    ValueAccessorBase.prototype.theInjector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/element-base.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 * @template T
 */
class ElementBase extends ValueAccessorBase {
    /**
     * @param {?} injector
     */
    constructor(injector) {
        super(injector);
        this.injector = injector;
        this.validator = validateControl;
    }
    /**
     * @param {?} control
     * @return {?}
     */
    validate(control) {
        return this.validator(control, this.model);
    }
}
ElementBase.propDecorators = {
    model: [{ type: Input }]
};
if (false) {
    /**
     * @type {?}
     * @protected
     */
    ElementBase.prototype.ngModel;
    /** @type {?} */
    ElementBase.prototype.model;
    /** @type {?} */
    ElementBase.prototype.validator;
    /** @type {?} */
    ElementBase.prototype.r;
    /**
     * @type {?}
     * @protected
     */
    ElementBase.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-input-for/ngx-input-for.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxInputForComponent extends ElementBase {
    /**
     * @param {?} el
     * @param {?} injector
     */
    constructor(el, injector) {
        super(injector);
        this.el = el;
        this.injector = injector;
        this.DataTypeEnum = DataTypeEnum;
        this.placeHolder = '';
        this.name = '';
        this.blur = new EventEmitter();
        this.readonly = false;
        this.ngxInput = true;
    }
    /**
     * @return {?}
     */
    onFocusout() {
        this.blur.emit();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set templates(value) {
        if (this.model) {
            value.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                this._template = item;
            }));
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.model) {
            console.error('ngx-validator error! [model] property is not binded!');
        }
        if (this.field === null || this.field === undefined) {
            this.field = this.el.nativeElement.getAttribute('name') === null
                ? this.el.nativeElement.getAttribute('id')
                : this.el.nativeElement.getAttribute('name');
        }
        if (!this.field) {
            this.field = this.el.nativeElement.getAttribute('formControlName');
        }
        /** @type {?} */
        const attribs = getDecorators(this.model, this.field);
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'DataType'))) {
            this.dataType = ((/** @type {?} */ (attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'DataType')).value))).value;
        }
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'Placeholder'))) {
            this.placeHolder = attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'Placeholder')).value;
        }
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'ReadOnly'))) {
            this.readonly = true;
        }
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'Name'))) {
            this.name = attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'Name')).value;
        }
        else {
            this.name = this.field;
        }
    }
    /**
     * @return {?}
     */
    getTemplate() {
        return this._template['templateRef'];
    }
}
NgxInputForComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-input-for',
                template: "<ng-container [ngSwitch]=\"dataType\">\n    <ng-container *ngIf=\"!_template; else template\">\n        <a\n            [href]=\"value\"\n            *ngSwitchCase=\"DataTypeEnum.Url\"\n            class=\"ngx-input-child-url\"\n            [id]=\"field\">\n            {{name | translate}}\n        </a>\n        <input\n            type=\"password\"\n            *ngSwitchCase=\"DataTypeEnum.Password\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child\"\n            [readOnly]=\"readonly\">\n        <img\n            *ngSwitchCase=\"DataTypeEnum.ImageUrl\"\n            [src]=\"value\"\n            class=\"ngx-input-child-image\"\n            [id]=\"field\">\n        <input\n            type=\"file\"\n            *ngSwitchCase=\"DataTypeEnum.Upload\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child-upload\"\n            [readOnly]=\"readonly\">\n        <textarea\n            *ngSwitchCase=\"DataTypeEnum.MultilineText\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child-textarea\"\n            rows=\"5\"\n            [readOnly]=\"readonly\"></textarea>\n        <input\n            *ngSwitchDefault\n            type=\"text\"\n            [placeholder]=\"placeHolder | translate\"\n            [(ngModel)]=\"value\"\n            [id]=\"field\"\n            [disabled]=\"this.disabled\"\n            class=\"ngx-input-child\"\n            [readOnly]=\"readonly\"\n            [name]=\"field\">\n    </ng-container>\n    <ng-template #template>\n        <ng-container\n            [ngTemplateOutlet]=\"getTemplate()\"\n            [ngTemplateOutletContext]=\"{$implicit: model}\">\n        </ng-container>\n    </ng-template>\n</ng-container>\n",
                providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => NgxInputForComponent)), multi: true },
                    { provide: NG_VALIDATORS, useExisting: NgxInputForComponent, multi: true }
                ]
            }] }
];
/** @nocollapse */
NgxInputForComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Injector }
];
NgxInputForComponent.propDecorators = {
    dataItems: [{ type: Input }],
    blur: [{ type: Output }],
    field: [{ type: Input }],
    ngModel: [{ type: ViewChild, args: [NgModel, { static: false },] }],
    formControlName: [{ type: ViewChild, args: [FormControlName, { static: false },] }],
    ngxInput: [{ type: HostBinding, args: ['class.ngx-input',] }],
    onFocusout: [{ type: HostListener, args: ['focusout',] }],
    templates: [{ type: ContentChildren, args: [NgxCustomTemplateForDirective, { descendants: false },] }]
};
if (false) {
    /** @type {?} */
    NgxInputForComponent.prototype.DataTypeEnum;
    /** @type {?} */
    NgxInputForComponent.prototype.dataType;
    /** @type {?} */
    NgxInputForComponent.prototype.placeHolder;
    /** @type {?} */
    NgxInputForComponent.prototype.name;
    /** @type {?} */
    NgxInputForComponent.prototype._template;
    /** @type {?} */
    NgxInputForComponent.prototype.dataItems;
    /** @type {?} */
    NgxInputForComponent.prototype.blur;
    /** @type {?} */
    NgxInputForComponent.prototype.readonly;
    /** @type {?} */
    NgxInputForComponent.prototype.field;
    /** @type {?} */
    NgxInputForComponent.prototype.ngModel;
    /** @type {?} */
    NgxInputForComponent.prototype.formControlName;
    /** @type {?} */
    NgxInputForComponent.prototype.ngxInput;
    /** @type {?} */
    NgxInputForComponent.prototype.el;
    /**
     * @type {?}
     * @protected
     */
    NgxInputForComponent.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-form-for/ngx-form-for.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxFormForComponent {
    constructor() {
        this.propertyNames = [];
        this.submitForm = new EventEmitter();
        this._templates = [];
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set model(value) {
        this._model = value;
        for (const item of Object.keys(this._model)) {
            /** @type {?} */
            const attribs = getDecorators(this._model, item);
            if (!attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'NoForm'))) {
                this.propertyNames.push({ field: item, template: false });
            }
        }
        for (const item of Reflect.getMetadataKeys(this._model)) {
            /** @type {?} */
            const attribs = getDecorators(this._model, item);
            if (!attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'NoForm')) && this.propertyNames.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.field === item)) === undefined) {
                this.propertyNames.push({ field: item, template: false });
            }
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set templates(value) {
        if (this._model) {
            value.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (this.propertyNames.find((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.field === item.ngxCustomTemplateFor))) {
                    this._templates.push(item);
                    this.propertyNames.find((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => x.field === item.ngxCustomTemplateFor)).template = true;
                }
                else {
                    throw (new Error(`Property name bound on NgxCustomTemplateForDirective ${item.ngxCustomTemplateFor} not found.
           If it is definity correct, please check if you have initialized it before passing model to ngx-form-for component`));
                }
            }));
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getTemplate(field) {
        return this._templates.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.ngxCustomTemplateFor === field))['templateRef'];
    }
    /**
     * @return {?}
     */
    submit() {
        this.submitForm.emit(this._model);
    }
}
NgxFormForComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-form-for',
                template: "<form\n    #form=\"ngForm\"\n    (ngSubmit)=\"submit()\"\n    [autocomplete]=\"autoComplete\">\n    <div\n        [ngClass]=\"cssClasses?.group? cssClasses.group : 'ngx-form-for'\"\n        *ngFor=\"let item of propertyNames\">\n        <ng-container *ngIf=\"!item.template; else template\">\n            <ngx-label-for\n                [model]=\"_model\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses?.label ? cssClasses?.label: ''\"></ngx-label-for>\n            <ngx-input-for\n                [id]=\"item.field\"\n                [model]=\"_model\"\n                [(ngModel)]=\"_model[item.field]\"\n                [ngModelOptions]=\"{ name: item.field }\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses?.input ? cssClasses.input: ''\"></ngx-input-for>\n            <ngx-validator-for\n                [errors]=\"form.controls[item.field]?.errors\"\n                [ngClass]=\"cssClasses?.error ? cssClasses.error: ''\">\n            </ngx-validator-for>\n        </ng-container>\n        <ng-template #template>\n            <!-- temporary form validation workaround. custom temlpate is not binded to form's controls and therefore, form validation doesn't work. help needed -->\n            <input\n                [name]=\"item.field\"\n                [(ngModel)]=\"_model[item.field]\"\n                [ngx-validator]=\"_model\"\n                style=\"display:none\">\n            <ng-container\n                [ngTemplateOutlet]=\"getTemplate(item.field)\"\n                [ngTemplateOutletContext]=\"{$implicit: {model: _model, form: form}}\">\n            </ng-container>\n        </ng-template>\n    </div>\n    <button\n        type=\"submit\"\n        [disabled]=\"form.invalid\"\n        class=\"btn btn-success\">\n        Submit\n    </button>\n</form>\n"
            }] }
];
/** @nocollapse */
NgxFormForComponent.ctorParameters = () => [];
NgxFormForComponent.propDecorators = {
    model: [{ type: Input }],
    cssClasses: [{ type: Input }],
    autoComplete: [{ type: Input }],
    form: [{ type: ViewChild, args: [NgForm, { static: false },] }],
    submitForm: [{ type: Output }],
    templates: [{ type: ContentChildren, args: [NgxCustomTemplateForDirective, { descendants: false },] }]
};
if (false) {
    /** @type {?} */
    NgxFormForComponent.prototype._model;
    /** @type {?} */
    NgxFormForComponent.prototype.cssClasses;
    /** @type {?} */
    NgxFormForComponent.prototype.autoComplete;
    /** @type {?} */
    NgxFormForComponent.prototype.form;
    /** @type {?} */
    NgxFormForComponent.prototype.propertyNames;
    /** @type {?} */
    NgxFormForComponent.prototype.submitForm;
    /** @type {?} */
    NgxFormForComponent.prototype._templates;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-form-for-reactive/ngx-form-for-reactive.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxFormForReactiveComponent {
    constructor() {
        this.propertyNames = [];
        this.submitForm = new EventEmitter();
        this._templates = [];
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set model(value) {
        this._model = value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set formGroup(value) {
        this._formGroup = value;
        for (const item of Object.keys(this._model)) {
            /** @type {?} */
            const attribs = getDecorators(this._model, item);
            if (!attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'NoForm')) && this._formGroup.controls[item]) {
                this.propertyNames.push({ field: item, template: false });
            }
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set templates(value) {
        if (this._model) {
            value.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (this.propertyNames.find((/**
                 * @param {?} x
                 * @return {?}
                 */
                x => x.field === item.ngxCustomTemplateFor))) {
                    this._templates.push(item);
                    this.propertyNames.find((/**
                     * @param {?} x
                     * @return {?}
                     */
                    x => x.field === item.ngxCustomTemplateFor)).template = true;
                }
                else {
                    throw (new Error(`Property name bound on NgxCustomTemplateForDirective ${item.ngxCustomTemplateFor} not found.
           If it is definity correct, please check if you have initialized it before passing model to ngx-form-for component`));
                }
            }));
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} field
     * @return {?}
     */
    getTemplate(field) {
        return this._templates.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.ngxCustomTemplateFor === field))['templateRef'];
    }
    /**
     * @return {?}
     */
    submit() {
        this.submitForm.emit(this._model);
    }
    /**
     * @param {?} item
     * @return {?}
     */
    controlExists(item) {
        if (this.formGroup.controls[item]) {
            return true;
        }
        else {
            return false;
        }
    }
}
NgxFormForReactiveComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-form-for-reactive',
                template: "<form\n    #form=\"ngForm\"\n    (ngSubmit)=\"submit()\"\n    [autocomplete]=\"autoComplete\"\n    [formGroup]=\"_formGroup\">\n    <div\n        [ngClass]=\"cssClasses? cssClasses.group: 'ngx-form-for'\"\n        *ngFor=\"let item of propertyNames\">\n        <ng-container *ngIf=\"!item.template; else template\">\n            <ngx-label-for\n                [model]=\"_model\"\n                [field]=\"item.field\"\n                [ngClass]=\"cssClasses? cssClasses.label:''\"></ngx-label-for>\n            <ngx-input-for\n                [formControlName]=\"item.field\"\n                [model]=\"_model\"\n                [ngClass]=\"cssClasses? cssClasses.input:''\"></ngx-input-for>\n            <ngx-validator-for\n                [errors]=\"_formGroup.get(item.field)?.errors\"\n                [ngClass]=\"cssClasses? cssClasses.error: ''\">\n            </ngx-validator-for>\n        </ng-container>\n        <ng-template #template>\n            <!-- temporary form validation workaround. custom temlpate is not binded to form's controls and therefore, form validation doesn't work. help needed -->\n            <input\n                [formControlName]=\"item.field\"\n                [ngx-validator]=\"_model\"\n                style=\"display:none\">\n            <ng-container\n                [ngTemplateOutlet]=\"getTemplate(item.field)\"\n                [ngTemplateOutletContext]=\"{$implicit: {model: _model, form: form}}\">\n            </ng-container>\n        </ng-template>\n    </div>\n    <button\n        type=\"submit\"\n        [disabled]=\"form.invalid\"\n        class=\"btn btn-success\">\n        Submit\n    </button>\n</form>\n"
            }] }
];
/** @nocollapse */
NgxFormForReactiveComponent.ctorParameters = () => [];
NgxFormForReactiveComponent.propDecorators = {
    cssClasses: [{ type: Input }],
    model: [{ type: Input }],
    formGroup: [{ type: Input }],
    autoComplete: [{ type: Input }],
    form: [{ type: ViewChild, args: [NgForm, { static: false },] }],
    submitForm: [{ type: Output }],
    templates: [{ type: ContentChildren, args: [NgxCustomTemplateForDirective, { descendants: false },] }]
};
if (false) {
    /** @type {?} */
    NgxFormForReactiveComponent.prototype._model;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype._formGroup;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype.cssClasses;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype.autoComplete;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype.form;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype.propertyNames;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype.submitForm;
    /** @type {?} */
    NgxFormForReactiveComponent.prototype._templates;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-dropdown-for/ngx-dropdown-for.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxDropdownForComponent extends ElementBase {
    /**
     * @param {?} el
     * @param {?} injector
     */
    constructor(el, injector) {
        super(injector);
        this.el = el;
        this.injector = injector;
        this.DataTypeEnum = DataTypeEnum;
        this.placeHolder = '';
        this.name = '';
        this.readonly = false;
        this.ngxDropdown = true;
        this.itemSource = [];
        this.valuePrimitive = true;
        this.defaultItem = true;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set templates(value) {
        if (this.model) {
            value.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                this._template = item;
            }));
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.model) {
            console.error('ngx-validator error! [model] property is not binded!');
        }
        if (this.field === null || this.field === undefined) {
            this.field = this.el.nativeElement.getAttribute('name') === null
                ? this.el.nativeElement.getAttribute('id')
                : this.el.nativeElement.getAttribute('name');
        }
        if (!this.field) {
            this.field = this.el.nativeElement.getAttribute('formControlName');
        }
        /** @type {?} */
        const attribs = getDecorators(this.model, this.field);
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'Placeholder'))) {
            this.placeHolder = attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'Placeholder')).value;
        }
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'ReadOnly'))) {
            this.readonly = true;
        }
        if (attribs.find((/**
         * @param {?} x
         * @return {?}
         */
        x => x.key === 'Name'))) {
            this.name = attribs.find((/**
             * @param {?} x
             * @return {?}
             */
            x => x.key === 'Name')).value;
        }
        else {
            this.name = this.field;
        }
    }
}
NgxDropdownForComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'ngx-dropdown-for',
                template: "<select\n    [(ngModel)]=\"value\"\n    [ngStyle]=\"{'color':'red'}\"\n    class=\"ngx-dropdown-child\">\n    <option\n        value=\"undefined\"\n        disabled\n        class=\"ngx-dropdown-child-default\"\n        selected\n        hidden\n        *ngIf=\"defaultItem\">\n        {{placeHolder}}\n    </option>\n    <ng-container *ngIf=\"valuePrimitive; else nonPrimitve\">\n        <option\n            *ngFor=\"let item of itemSource\"\n            [ngValue]=\"item[key]\">\n            {{item[text]}}\n        </option>\n    </ng-container>\n    <ng-template #nonPrimitve>\n        <option\n            *ngFor=\"let item of itemSource\"\n            [ngValue]=\"item\">\n            {{item[text]}}\n        </option>\n    </ng-template>\n</select>\n",
                providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: NgxDropdownForComponent, multi: true },
                    { provide: NG_VALIDATORS, useExisting: NgxDropdownForComponent, multi: true }
                ]
            }] }
];
/** @nocollapse */
NgxDropdownForComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: Injector }
];
NgxDropdownForComponent.propDecorators = {
    ngxDropdown: [{ type: HostBinding, args: ['class.ngx-dropdown',] }],
    itemSource: [{ type: Input }],
    field: [{ type: Input }],
    key: [{ type: Input }],
    valuePrimitive: [{ type: Input }],
    text: [{ type: Input }],
    ngModel: [{ type: ViewChild, args: [NgModel, { static: false },] }],
    defaultItem: [{ type: Input }],
    templates: [{ type: ContentChildren, args: [NgxCustomTemplateForDirective, { descendants: false },] }]
};
if (false) {
    /** @type {?} */
    NgxDropdownForComponent.prototype.DataTypeEnum;
    /** @type {?} */
    NgxDropdownForComponent.prototype.placeHolder;
    /** @type {?} */
    NgxDropdownForComponent.prototype.name;
    /** @type {?} */
    NgxDropdownForComponent.prototype._template;
    /** @type {?} */
    NgxDropdownForComponent.prototype.readonly;
    /** @type {?} */
    NgxDropdownForComponent.prototype.ngxDropdown;
    /** @type {?} */
    NgxDropdownForComponent.prototype.itemSource;
    /** @type {?} */
    NgxDropdownForComponent.prototype.field;
    /** @type {?} */
    NgxDropdownForComponent.prototype.key;
    /** @type {?} */
    NgxDropdownForComponent.prototype.valuePrimitive;
    /** @type {?} */
    NgxDropdownForComponent.prototype.text;
    /** @type {?} */
    NgxDropdownForComponent.prototype.ngModel;
    /** @type {?} */
    NgxDropdownForComponent.prototype.defaultItem;
    /** @type {?} */
    NgxDropdownForComponent.prototype.el;
    /**
     * @type {?}
     * @protected
     */
    NgxDropdownForComponent.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-validator.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxValidatorModule {
}
NgxValidatorModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    TranslateModule
                ],
                declarations: [
                    NgxValidatorDirective,
                    NgxLabelForComponent,
                    NgxValidatorForComponent,
                    NgxInputForComponent,
                    NgxFormForComponent,
                    NgxCustomTemplateForDirective,
                    NgxFormForReactiveComponent,
                    NgxDropdownForComponent
                ],
                exports: [
                    NgxValidatorDirective,
                    NgxLabelForComponent,
                    NgxValidatorForComponent,
                    NgxInputForComponent,
                    NgxFormForComponent,
                    NgxCustomTemplateForDirective,
                    NgxFormForReactiveComponent,
                    NgxDropdownForComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-validator.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Compare, Contains, CreditCard, Custom, DataType, DataTypeEnum, Email, MaxValue, MinValue, ModelState, Name, NgxValidatorDirective, NgxValidatorModule, NoForm, NotContains, Pattern, Placeholder, Range, ReadOnly, Required, RequiredIf, StringLength, configurable, getDecorators, ngxValidate, NgxLabelForComponent as ɵa, NgxValidatorForComponent as ɵb, NgxInputForComponent as ɵc, ElementBase as ɵd, ValueAccessorBase as ɵe, NgxCustomTemplateForDirective as ɵf, NgxFormForComponent as ɵg, NgxFormForReactiveComponent as ɵh, NgxDropdownForComponent as ɵi };
//# sourceMappingURL=ngx-validator.js.map
